<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="名称" prop="name">
        <el-input v-model="formData.name" placeholder="请输入名称" />
      </el-form-item>
      <el-form-item label="类型" prop="type">
        <el-select v-model="formData.type" placeholder="请选择类型">
          <el-option
            v-for="dict in getIntDictOptions(DICT_TYPE.CAMERA_TYPE)"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="ip" prop="ip">
        <el-input v-model="formData.ip" placeholder="请输入ip" />
      </el-form-item>
      <el-form-item label="端口" prop="port">
        <el-input v-model="formData.port" placeholder="请输入端口" />
      </el-form-item>
      <el-form-item label="用户名" prop="user">
        <el-input v-model="formData.user" placeholder="请输入用户名" />
      </el-form-item>
      <el-form-item label="密码" prop="password">
        <el-input v-model="formData.password" placeholder="请输入密码" />
      </el-form-item>
      <el-form-item label="流媒体ip" prop="rtcServer">
        <el-input v-model="formData.rtcServer" placeholder="请输入流媒体ip" />
      </el-form-item>
      <el-form-item label="流媒体端口" prop="rtcServerPort">
        <el-input v-model="formData.rtcServerPort" placeholder="请输入流媒体端口" />
      </el-form-item>
      <el-form-item label="rtsp端口" prop="rtspPort">
        <el-input v-model="formData.rtspPort" placeholder="请输入rtsp端口" />
      </el-form-item>
      <el-form-item label="通道" prop="channel">
        <el-input v-model="formData.channel" placeholder="请输入通道" />
      </el-form-item>
      <el-form-item label="录像机ip" prop="recorderIp">
        <el-input v-model="formData.recorderIp" placeholder="请输入录像机ip" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { getIntDictOptions, DICT_TYPE } from '@/utils/dict'
import {getTypeList} from '@/api/system/dict/dict.data'
import { CameraApi, CameraVO } from '@/api/logistics/camera'
import { number } from 'vue-types'

/** 相机 表单 */
defineOptions({ name: 'CameraForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref<{
  id?: number
  name?: string
  type?: number
  ip?: string
  port?: number
  user?: string
  password?: string
  rtcServer?: string
  rtcServerPort?: number
  rtspPort?: number // 修正为 number | undefined
  channel?: string
  recorderIp?: string
}>({
  id: undefined,
  name: undefined,
  type: undefined,
  ip: undefined,
  port: undefined,
  user: undefined,
  password: undefined,
  rtcServer: undefined,
  rtcServerPort: undefined,
  rtspPort: undefined, // 初始化为 undefined，但允许 number
  channel: undefined,
  recorderIp: undefined,
})
const formRules = reactive({
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await CameraApi.getCamera(id)
    } finally {
      formLoading.value = false
    }
  }else{
    const cameraConf = await getTypeList(DICT_TYPE.CAMERA_CONF)
    for(let i = 0; i < cameraConf.length; i++){
      if(cameraConf[i].label == 'camera_password'){
        formData.value.password = cameraConf[i].value
      }else if(cameraConf[i].label == 'camera_type'){
        formData.value.type = Number(cameraConf[i].value)
      }else if(cameraConf[i].label == 'camera_user'){
        formData.value.user = cameraConf[i].value
      }else if(cameraConf[i].label == 'camera_port'){
        formData.value.port = cameraConf[i].value
      }else if(cameraConf[i].label == 'rtc_server_ip'){
        formData.value.rtcServer = cameraConf[i].value
      }else if(cameraConf[i].label == 'rtc_server_port'){
        formData.value.rtcServerPort = cameraConf[i].value
      }else if(cameraConf[i].label == 'rtsp_port'){
        formData.value.rtspPort = cameraConf[i].value
      }else if(cameraConf[i].label == 'camera_cannel'){
        formData.value.channel = cameraConf[i].value
      }
    }
    console.log(cameraConf);
    
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as CameraVO
    if (formType.value === 'create') {
      await CameraApi.createCamera(data)
      message.success(t('common.createSuccess'))
    } else {
      await CameraApi.updateCamera(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    name: undefined,
    type: undefined,
    ip: undefined,
    port: undefined,
    user: undefined,
    password: undefined,
    rtcServer: undefined,
    rtcServerPort: undefined,
    rtspPort: undefined,
    channel: undefined,
    recorderIp: undefined,
  }
  formRef.value?.resetFields()
}
</script>